Home | History | Annotate | Download | only in rbind
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test29} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST29***************"
     29 tst_resm TINFO "rbind: shared subtree with uncloneable child to shared subtree."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of rbind/test29 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent1
     45 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 	"${FS_BIND_ROOT}/bin/makedir" share share2
     48 
     49 	mount --rbind share1 parent1
     50 	mount --rbind share2 parent2
     51 
     52 	"${FS_BIND_ROOT}/bin/makedir" unclone parent1/child1
     53 	mount --rbind "$disk1" parent1/child1
     54 	mount --rbind parent1 parent2
     55 
     56 	check -n parent1/child1 share1/child1
     57 	check -n parent1/child1 parent2/child1
     58 	check parent2/child1 share2/child1
     59 
     60 	break
     61 done
     62 trap 'ERR=$? ; tst_resm TWARN "rbind/test29: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     63 if [ -n "${ERR_MSG}" ]; then
     64 	tst_resm TWARN "rbind/test29: ${ERR_MSG}"
     65 	ERR_MSG=""
     66 	result=$ERR
     67 fi
     68 trap '' ERR
     69 {
     70 	umount parent1/child1
     71 	umount parent1/child1
     72 	umount share2
     73 	umount share2
     74 	umount parent2
     75 	umount parent1
     76 	umount share1
     77 	umount parent1
     78 	umount share2
     79 
     80 	rm -rf parent* share*
     81 	cleanup
     82 } >& /dev/null
     83 if [ $result -ne 0 ]
     84 then
     85 	tst_resm TFAIL "rbind/test29: FAILED: rbind: shared subtree with uncloneable child to shared subtree."
     86 	exit 1
     87 else
     88 	tst_resm TPASS "rbind/test29: PASSED"
     89 	exit 0
     90 fi
     91 tst_exit
     92